"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withRetryLoop = exports.pollUntil = exports.asyncWithTimeout = exports.abortableWait = exports.triggerPromise = exports.wait = exports.elapsed = void 0;

var R = _interopRequireWildcard(require("ramda"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var sProcessStart = Date.now() / 1e3;
var hrTimeProcessStart = globalThis.process && process.hrtime && process.hrtime();
var elapsed = globalThis.process && process.hrtime ? function () {
  var hr = process.hrtime(hrTimeProcessStart);
  return sProcessStart + (hr[0] + hr[1] / 1e9);
} : function () {
  return Date.now() / 1e3 - sProcessStart;
};
exports.elapsed = elapsed;

var wait = function wait(delay) {
  return new Promise(function (r) {
    return setTimeout(r, delay);
  });
};

exports.wait = wait;

var triggerPromise = function triggerPromise() {
  var resolve;
  var reject;
  var promise = new Promise(function (res, rej) {
    resolve = res;
    reject = rej;
  });
  return [promise, resolve, reject];
};

exports.triggerPromise = triggerPromise;

var abortableWait = function abortableWait(delay) {
  var _triggerPromise = triggerPromise(),
      _triggerPromise2 = _slicedToArray(_triggerPromise, 2),
      promise = _triggerPromise2[0],
      resolve = _triggerPromise2[1];

  var timer = setTimeout(resolve, delay);
  return [promise, function () {
    clearTimeout(timer);
    resolve();
  }];
};

exports.abortableWait = abortableWait;

var asyncWithTimeout = function asyncWithTimeout(promise) {
  var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3e3;
  var timeoutResolve;
  var timer;
  var timeoutPromise = new Promise(function (resolve, reject) {
    timeoutResolve = resolve;
    timer = setTimeout(function () {
      return reject(new Error('asyncWithTimeout: Timeout'));
    }, timeout);
  });
  return Promise.race([promise["finally"](function () {
    clearTimeout(timer);
    timeoutResolve();
  }), timeoutPromise]);
};

exports.asyncWithTimeout = asyncWithTimeout;
var pollUntil = R.curry(function () {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$interval = _ref.interval,
      interval = _ref$interval === void 0 ? 10 : _ref$interval,
      _ref$ignoreReject = _ref.ignoreReject,
      ignoreReject = _ref$ignoreReject === void 0 ? false : _ref$ignoreReject,
      _ref$timeout = _ref.timeout,
      timeout = _ref$timeout === void 0 ? 0 : _ref$timeout;

  var compareFn = arguments.length > 1 ? arguments[1] : undefined;
  var fn = arguments.length > 2 ? arguments[2] : undefined;
  return new Promise(function (resolve, reject) {
    var abortWaitFunction;
    var timer;
    var waitPromise;
    var timedout = false; // Timeout handling

    if (timeout) {
      timer = setTimeout(function () {
        timedout = true;
        if (abortWaitFunction) abortWaitFunction();
        reject(new Error('pollUntil: Timeout'));
      }, timeout);
    } // Inner recursive function


    var inner =
    /*#__PURE__*/
    function () {
      var _ref2 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var result, threw, _abortableWait, _abortableWait2;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!timedout) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                threw = false;
                _context.prev = 3;
                _context.next = 6;
                return fn();

              case 6:
                result = _context.sent;
                _context.next = 16;
                break;

              case 9:
                _context.prev = 9;
                _context.t0 = _context["catch"](3);

                if (ignoreReject) {
                  _context.next = 15;
                  break;
                }

                clearTimeout(timer);
                reject(_context.t0);
                return _context.abrupt("return");

              case 15:
                threw = true;

              case 16:
                _context.t1 = !threw;

                if (!_context.t1) {
                  _context.next = 21;
                  break;
                }

                _context.next = 20;
                return compareFn(result);

              case 20:
                _context.t1 = _context.sent;

              case 21:
                if (!_context.t1) {
                  _context.next = 25;
                  break;
                }

                clearTimeout(timer);
                resolve(result);
                return _context.abrupt("return");

              case 25:
                _abortableWait = abortableWait(interval);
                _abortableWait2 = _slicedToArray(_abortableWait, 2);
                waitPromise = _abortableWait2[0];
                abortWaitFunction = _abortableWait2[1];
                _context.next = 31;
                return waitPromise;

              case 31:
                inner();

              case 32:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[3, 9]]);
      }));

      return function inner() {
        return _ref2.apply(this, arguments);
      };
    }(); // Startpoint of recursion


    inner();
  });
});
exports.pollUntil = pollUntil;

var withRetryLoop = function withRetryLoop() {
  var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      onRetry = _ref3.onRetry,
      _ref3$delay = _ref3.delay,
      delay = _ref3$delay === void 0 ? 1e3 : _ref3$delay,
      _ref3$delta = _ref3.delta,
      delta = _ref3$delta === void 0 ? 2e3 : _ref3$delta,
      _ref3$maxDelay = _ref3.maxDelay,
      maxDelay = _ref3$maxDelay === void 0 ? 6e4 : _ref3$maxDelay;

  return function (fn) {
    return function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return fn.apply(void 0, args)["catch"](function (err) {
        if (onRetry) onRetry(err, delay);
        return wait(delay).then(function () {
          return withRetryLoop({
            onRetry: onRetry,
            delay: Math.min(delay + delta, maxDelay),
            delta: delta,
            maxDelay: maxDelay
          })(fn).apply(void 0, args);
        });
      });
    };
  };
};

exports.withRetryLoop = withRetryLoop;